unit unPolyEditor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Polygon, StdCtrls, Buttons, ExtCtrls, ComCtrls, Menus, Spin,
  unStreamOps;

type
  TfoPolyEditor = class(TForm)
    MyPoly: TPolygon;
    PointList: TListBox;
    Panel1: TPanel;
    btOK: TBitBtn;
    btApply: TBitBtn;
    btCancel: TBitBtn;
    Panel3: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    Label4: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    SpeedButton10: TSpeedButton;
    SpeedButton11: TSpeedButton;
    SpeedButton12: TSpeedButton;
    SpeedButton13: TSpeedButton;
    OD: TOpenDialog;
    SD: TSaveDialog;
    SpeedButton14: TSpeedButton;
    SpeedButton15: TSpeedButton;
    SpeedButton16: TSpeedButton;
    seMove: TEdit;
    seRotate: TEdit;
    SpeedButton17: TSpeedButton;
    SpeedButton18: TSpeedButton;
    seShrink: TEdit;
    SpeedButton19: TSpeedButton;
    SpeedButton20: TSpeedButton;
    Label5: TLabel;
    procedure SpeedButton3Click(Sender: TObject);
    procedure btCancelClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MyPolyMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton9Click(Sender: TObject);
    procedure MyPolyChange(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure SpeedButton11Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton12Click(Sender: TObject);
    procedure SpeedButton13Click(Sender: TObject);
    procedure SpeedButton14Click(Sender: TObject);
    procedure btApplyClick(Sender: TObject);
    procedure btOKClick(Sender: TObject);
    procedure SpeedButton10Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure seMoveChange(Sender: TObject);
    procedure SpeedButton15Click(Sender: TObject);
    procedure SpeedButton16Click(Sender: TObject);
    procedure SpeedButton17Click(Sender: TObject);
    procedure SpeedButton18Click(Sender: TObject);
    procedure seRotateChange(Sender: TObject);
    procedure seShrinkChange(Sender: TObject);
    procedure SpeedButton19Click(Sender: TObject);
    procedure SpeedButton20Click(Sender: TObject);
  private
    { Private declarations }

    procedure GetPoints(Poly : TPolygon);
    procedure MovePoints(Dir : Boolean; Pixels : Integer);
    procedure Shrink(Perc : Integer);
    procedure Rotate(Degrees : Real);

  public
    { Public declarations }
    IsModified   : Boolean;
    FRealPoints  : TPoints;
  end;

var
  foPolyEditor: TfoPolyEditor;

implementation

{$R *.DFM}

Const
 XPan = 1;
 YPan = 2;

procedure TfoPolyEditor.GetPoints(Poly : TPolygon);
Var
 T : Integer;
begin
 PointList.Items.BeginUpdate;
 PointList.Clear;
 For T:= 0 to Poly.Points.Count-1 do
  begin
   With Poly.Points.Points[T] do
   PointList.Items.Add(IntToStr(T)+' X:'+IntToStr(x)+', Y:'+IntToStr(Y));
   //Format('%d %d %0:d %d', [T, 20]));
  end;
 PointList.Items.EndUpdate;
end;

procedure TfoPolyEditor.SpeedButton3Click(Sender: TObject);
begin
 IF PointList.ItemIndex<>-1 then
   MyPoly.Points.Delete(PointList.ItemIndex);
end;

procedure TfoPolyEditor.btCancelClick(Sender: TObject);
begin
 Close;
end;

procedure TfoPolyEditor.SpeedButton1Click(Sender: TObject);
Var
 Save : Integer;
begin
 IF PointList.ItemIndex <> -1 then
  Begin
   Save:=PointList.ItemIndex;
   IF Save <> 0 then
    Begin
     PointList.Items.Move(Save,Save-1);
     MyPoly.Points.Move(Save,Save-1);
     PointList.ItemIndex:=Save-1;
    end
   else
    Begin
      PointList.Items.Move(Save,PointList.Items.Count-1);
      MyPoly.Points.Move(Save,MyPoly.Points.Count-1);
      PointList.ItemIndex:=PointList.Items.Count-1;
    end;
  end;

end;

procedure TfoPolyEditor.FormCreate(Sender: TObject);
begin
 IsModified:=False;
 GetPoints(MyPoly);
end;

procedure TfoPolyEditor.MyPolyMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
 Label1.Caption:='X: '+IntToStr(X);
 Label2.Caption:='Y: '+IntToStr(Y);
end;

procedure TfoPolyEditor.MovePoints(Dir : Boolean; Pixels : Integer);
Var
 T : Integer;
Begin
 For T:= 0 to MyPoly.Points.Count-1 do
  Begin
   IF Dir then
      MyPoly.Points.Points[T].x:=MyPoly.Points.Points[T].x+Pixels
   else MyPoly.Points.Points[T].y:=MyPoly.Points.Points[T].y+Pixels;
  end;
End;

procedure TfoPolyEditor.Shrink(Perc : Integer);
Var
 T : Integer;
 Pt : TPoint;
Begin
 IF MyPoly.Points.Count<=0 then
  Exit;

 For T:= 0 to MyPoly.Points.Count-1 do
  Begin
   Pt.x:=Round(MyPoly.Points.Points[T].x*Perc/100);
   Pt.y:=Round(MyPoly.Points.Points[T].y*Perc/100);
   MyPoly.Points.Points[T].x:=Pt.x;
   MyPoly.Points.Points[T].y:=Pt.y;
  end;
End;

procedure TfoPolyEditor.SpeedButton5Click(Sender: TObject);
begin
 MovePoints(True,-seMove.Tag);
end;

procedure TfoPolyEditor.SpeedButton4Click(Sender: TObject);
begin
 MovePoints(True,seMove.Tag);
end;

procedure TfoPolyEditor.SpeedButton7Click(Sender: TObject);
begin
 MovePoints(False,seMove.Tag);
end;

procedure TfoPolyEditor.SpeedButton6Click(Sender: TObject);
begin
 MovePoints(False,-seMove.Tag);
end;

procedure TfoPolyEditor.SpeedButton9Click(Sender: TObject);
begin
 Shrink(seShrink.Tag);
end;

procedure TfoPolyEditor.MyPolyChange(Sender: TObject);
begin
 GetPoints(MyPoly);
 Invalidate;
 btCancel.Enabled:=True;
 btApply.Enabled:=True;
end;

procedure TfoPolyEditor.Rotate(Degrees : Real);
Var
 T : Integer;
 x1,y1 : Integer;
 x,y : Integer;
 A : Real;

Function DegToRads(Deg : Real):Real;
Begin
 Result := Deg * PI / 180;
end;

begin
 MyPoly.Points.BeginUpdate;
 For T := 0 to MyPoly.Points.Count-1 do
  Begin
   A:=DegToRads(Degrees);
   X:=MyPoly.Points.Points[T].x-(MyPoly.Width div 2);
   Y:=MyPoly.Points.Points[T].y-(MyPoly.Height div 2);
   X1 := Round(x * Cos(A) + y * Sin(A));
   Y1 := Round(y * Cos(A) - X * Sin(A));
   MyPoly.Points.Points[T].x:=(MyPoly.Width div 2) + x1;
   MyPoly.Points.Points[T].y:=(MyPoly.Height div 2) + y1;
 end;
 MyPoly.Points.EndUpdate; 
end;

procedure TfoPolyEditor.SpeedButton8Click(Sender: TObject);
begin
 Rotate(seRotate.Tag);
end;

procedure TfoPolyEditor.SpeedButton11Click(Sender: TObject);
Var
 T : Integer;
 M : TPoint;
begin
 MyPoly.Points.BeginUpdate;
 M.x:=MyPoly.Width div 2;
 M.y:=MyPoly.Height div 2;
 For T := 0 to MyPoly.Points.Count-1 do
  Begin
   MyPoly.Points.Points[T].x:=M.x+(M.x-MyPoly.Points.Points[T].x);
   //MyPoly.Points.Points[T].y:=M.y+(M.y-MyPoly.Points.Points[T].y);
  end;
 MyPoly.Points.EndUpdate;
end;

procedure TfoPolyEditor.SpeedButton2Click(Sender: TObject);
Var
 Save : Integer;
begin
 IF PointList.ItemIndex <> -1 then
  Begin
   Save:=PointList.ItemIndex;
   IF Save <> PointList.Items.Count-1 then
    Begin
     PointList.Items.Move(Save,Save+1);
     MyPoly.Points.Move(Save,Save+1);
     PointList.ItemIndex:=Save+1;
    end
   else
    Begin
      PointList.Items.Move(Save,0);
      MyPoly.Points.Move(Save,0);
      PointList.ItemIndex:=0;
    end;
  end;

end;
procedure TfoPolyEditor.SpeedButton12Click(Sender: TObject);
begin
 IF OD.Execute then
  MyPoly.Points.LoadFromFile(OD.FileName); 
end;

procedure TfoPolyEditor.SpeedButton13Click(Sender: TObject);
begin
 IF SD.Execute then
  MyPoly.Points.SaveToFile(SD.FileName);
end;

procedure TfoPolyEditor.SpeedButton14Click(Sender: TObject);
begin
 MyPoly.Points.Clear;
 MyPoly.Points.EndUpdate;
end;

procedure TfoPolyEditor.btApplyClick(Sender: TObject);
begin
 IsModified:=True;
 FRealPoints.Assign(MyPoly.Points);
 btCancel.Enabled:=False;
 btApply.Enabled:=False;
end;

procedure TfoPolyEditor.btOKClick(Sender: TObject);
begin
 IsModified:=True;
 FRealPoints.Assign(MyPoly.Points);
end;

procedure TfoPolyEditor.SpeedButton10Click(Sender: TObject);
Var
 T : Integer;
 M : TPoint;
begin
 MyPoly.Points.BeginUpdate;
 M.x:=MyPoly.Width div 2;
 M.y:=MyPoly.Height div 2;
 For T := 0 to MyPoly.Points.Count-1 do
  Begin
   //MyPoly.Points.Points[T].x:=M.x-(M.x-MyPoly.Points.Points[T].x);
   MyPoly.Points.Points[T].y:=M.y+(M.y-MyPoly.Points.Points[T].y);
  end;
 MyPoly.Points.EndUpdate;
end;

procedure TfoPolyEditor.FormShow(Sender: TObject);
begin
 GetPoints(MyPoly);
end;

function ValidateTag(S : String):Integer;
Var
 T  : Integer;
 S2 : String;
Begin
 S2:='';
 For T := 1 to Length(S) do
  Case S[T] of
   '0','1'..'9' : S2:=S2+S[T];
  end;
 S2:='0'+s2;

 Result:=StrToInt(s2);
end;

procedure TfoPolyEditor.seMoveChange(Sender: TObject);
begin
 With seMove do
  Begin
   Tag:=ValidateTag(Text);
   Text:=IntToStr(Tag);
  end;
end;

procedure TfoPolyEditor.SpeedButton15Click(Sender: TObject);
begin
  seMove.Tag:=seMove.Tag+1;
  seMove.Text:=IntToStr(seMove.Tag);
end;

procedure TfoPolyEditor.SpeedButton16Click(Sender: TObject);
begin
  seMove.Tag:=seMove.Tag-1;
  seMove.Text:=IntToStr(seMove.Tag);
end;


procedure TfoPolyEditor.SpeedButton17Click(Sender: TObject);
begin
  seRotate.Tag:=seRotate.Tag+1;
  seRotate.Text:=IntToStr(seRotate.Tag);
end;

procedure TfoPolyEditor.SpeedButton18Click(Sender: TObject);
begin
  seRotate.Tag:=seRotate.Tag-1;
  seRotate.Text:=IntToStr(seRotate.Tag);
end;

procedure TfoPolyEditor.seRotateChange(Sender: TObject);
begin
 With seRotate do
  Begin
   Tag:=ValidateTag(Text);
   Text:=IntToStr(Tag);
  end;
end;


procedure TfoPolyEditor.seShrinkChange(Sender: TObject);
begin
  With seShrink do
  Begin
   Tag:=ValidateTag(Text);
   Text:=IntToStr(Tag);
  end;
end;

procedure TfoPolyEditor.SpeedButton19Click(Sender: TObject);
begin
  seShrink.Tag:=seShrink.Tag-1;
  seShrink.Text:=IntToStr(seShrink.Tag);
end;

procedure TfoPolyEditor.SpeedButton20Click(Sender: TObject);
begin
  seShrink.Tag:=seShrink.Tag+1;
  seShrink.Text:=IntToStr(seShrink.Tag);
end;


end.
